﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace FoCAsGenerator
{
    public partial class FoCAsGenerator : Form
    {
        public FoCAsGenerator()
        {
            InitializeComponent();
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog FolderBrowserDialog1 = new FolderBrowserDialog()
            {
                SelectedPath = this.txtDirectory.Text,
                ShowNewFolderButton = true,
                Description = "Select folder with FoCAs report files"
            };

            if (FolderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                this.txtDirectory.Text = FolderBrowserDialog1.SelectedPath;
            }
        }

        private void btnGenerate_Click(object sender, EventArgs e)
        {
            try
            {
                this.txtOutput.AppendText("Generating mass FoCAs report from multiple AAVSO reports\n");
                if (Directory.Exists(this.txtDirectory.Text))
                {
                    this.txtOutput.AppendText("Directory Exists\n");

                    string[] files = Directory.GetFiles(this.txtDirectory.Text, this.txtWildcard.Text, SearchOption.AllDirectories);
                    this.txtOutput.AppendText("FoCAs Report files found: " + files.Count() + "\n");

                    if (files.Count() != 0)
                    {
                        //string outputFile = this.txtDirectory.Text + @"\" + this.txtFilename.Text;
                        string outputFile = Path.Combine(this.txtDirectory.Text, this.txtFilename.Text);
                        if (File.Exists(outputFile))
                        {
                            outputFile = Path.Combine(this.txtDirectory.Text, Path.GetFileNameWithoutExtension(outputFile) + DateTime.Now.Year + DateTime.Now.Month + DateTime.Now.Day + DateTime.Now.Hour + DateTime.Now.Minute + DateTime.Now.Second + DateTime.Now.Millisecond + @".txt");
                            this.txtOutput.AppendText("Supplied FoCAs report filename already exists.  Renaming to: " + outputFile + "\n");
                        }
                        this.txtOutput.AppendText("Generating output file: " + outputFile + "\n");
                        StreamWriter fileWriter = new StreamWriter(outputFile, true);

                        string outputFile2 = Path.Combine(this.txtDirectory.Text, this.txtFilename2.Text);
                        if (File.Exists(outputFile2))
                        {
                            outputFile2 = Path.Combine(this.txtDirectory.Text, Path.GetFileNameWithoutExtension(outputFile2) + DateTime.Now.Year + DateTime.Now.Month + DateTime.Now.Day + DateTime.Now.Hour + DateTime.Now.Minute + DateTime.Now.Second + DateTime.Now.Millisecond + @".txt");
                            this.txtOutput.AppendText("Supplied Afhro report filename already exists.  Renaming to: " + outputFile2 + "\n");
                        }
                        this.txtOutput.AppendText("Generating output file: " + outputFile2 + "\n");
                        StreamWriter fileWriter2 = new StreamWriter(outputFile2, true);

                        for (int i = 0; i < files.Count(); i++)
                        {
                            this.txtOutput.AppendText("Processing file: " + files[i].ToString() + "\n");
                            //StreamReader file = new StreamReader(this.txtDirectory.Text + @"\" + files[i].ToString());
                            StreamReader file = new StreamReader(files[i].ToString());

                            string line;
                            int nrofline = 1;
                            while ((line = file.ReadLine()) != null)
                            {
                                if (i == 0)
                                {
                                    //Eerste file, kopieer alle lijnen
                                    if (nrofline==5 || nrofline==6 || nrofline==7 || nrofline==8 || nrofline == 9)
                                    {
                                        fileWriter.WriteLine(line);
                                        this.txtOutput.AppendText(line + "\n");
                                    }

                                    if (nrofline==12 || nrofline==13 || nrofline == 14)
                                    {
                                        fileWriter2.WriteLine(line);
                                        this.txtOutput.AppendText(line + "\n");
                                    }
                                }
                                else
                                {
                                    //Alle andere files, kopieer enkel de datalijnen
                                    //if (line.Substring(0, 1) != "#")
                                    //{
                                    //    fileWriter.WriteLine(line);
                                    //    this.txtOutput.AppendText(line + "\n");
                                    //}
                                    if (nrofline==8 || nrofline == 9)
                                    {
                                        fileWriter.WriteLine(line);
                                        this.txtOutput.AppendText(line + "\n");
                                    }

                                    if (nrofline == 14)
                                    {
                                        fileWriter2.WriteLine(line);
                                        this.txtOutput.AppendText(line + "\n");
                                    }
                                }
                                nrofline++;
                            }

                            file.Close();
                            file.Dispose();
                            file = null;

                        }
                        fileWriter.Flush();
                        fileWriter.Close();
                        fileWriter2.Flush();
                        fileWriter2.Close();
                        this.txtOutput.AppendText("Generation DONE !\n");
                        fileWriter = null;
                        fileWriter2 = null;
                        outputFile = null;
                    }
                    else
                    {
                        this.txtOutput.AppendText("No FoCAs report files found.  Exiting.\n");
                    }
                    files = null;

                }
                else
                {
                    this.txtOutput.AppendText("Supplied directory does not exist.  Exiting...\n");
                }
            }
            catch (Exception ex)
            {
                this.txtOutput.AppendText("ERROR: \n" + ex.ToString());
            }

        }

        private void label1_MouseHover(object sender, EventArgs e)
        {
            this.toolTip1.SetToolTip(this.label1, "Filename of mass FoCAs report to generate.");
        }

        private void label2_MouseHover(object sender, EventArgs e)
        {
            this.toolTip1.SetToolTip(this.label2, "Directory of all the FoCAs reports that needs to be merged.");
        }

        private void label4_MouseHover(object sender, EventArgs e)
        {
            this.toolTip1.SetToolTip(this.label4, "Wildcard to detect the FoCAs report files.");
        }

    }
}
